// dropDlgDlg.cpp : implementation file
//

#include "stdafx.h"
#include "dropDlg.h"
#include "dropDlgDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDropDlgDlg dialog

CDropDlgDlg::CDropDlgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDropDlgDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDropDlgDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDropDlgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDropDlgDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDropDlgDlg, CDialog)
	//{{AFX_MSG_MAP(CDropDlgDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDropDlgDlg message handlers

BOOL CDropDlgDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// register the OLE drop target window
	HRESULT hr = RegisterDragDrop(GetDlgItem(IDC_TARGET)->m_hWnd, &m_dropTarget);
	
	// connect the dialog to the drop target interface
	m_dropTarget.m_pwDialog = this;

	// Provide a default path for the target folder
	// If this is not a valid path, then files won't be accepted
	// You can specify a full path to a ZIP file too, or any other valid shell target
	GetDlgItem(IDC_FOLDER)->SetWindowText(_T("c:\\temp"));

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// the only possible exit, when <Esc> is hit or the [X] button kliked
void CDropDlgDlg::OnCancel() 
{
	// just before we exit, "unregister" the drop target window
	HRESULT hr = RevokeDragDrop(GetDlgItem(IDC_TARGET)->m_hWnd);
	
	CDialog::OnCancel();
}

void CDropDlgDlg::OnOK() 
{
	// just eat this, for the <Enter> key
}


/////////////////////////////////////////////////////////////////////////////
// CDropDlgDlg useless win3.1 compatibility handlers

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDropDlgDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDropDlgDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
